/**!
 *  Autocomplete Choice Input - v1.1.0
 *  jQuery plugin for fast selects with huge amount of options
 *  https://github.com/AlesJiranek/autocomplete-choice-input
 *
 *  Made by Aleš Jiránek
 *  Under MIT License
 */
!function(a,b){"use strict";function c(b,c){this.element=a(b),this.options=a.extend({},e,c),this.init()}var d="autocompleteChoiceInput",e={minLength:2,maxItems:10,singleText:!1,singleTextDelimiter:";",data:null,keyboardSupport:!0,allowAdd:!1,addText:"Create %item%...",addedPrefix:"",allowEdit:!1,endpoint:null};a.extend(c.prototype,{init:function(){this.buildContainer(),this.createInput(),this.setAutocompleteData(),this.createSelectedItemsList(),this.createSelectedItemsCounter(),this.createAutocompleteList(),this.addInputListener(),this.setDefaultSelectedItems()},setAutocompleteData:function(){this.autocompleteValues={},this.cache={};var c={};if(null===this.options.data?(c=this.element.data("options"),"undefined"==typeof c&&(this.element.is("select")?c=this.parseSelectOptions():this.options.endpoint?a.ajax({url:this.options.endpoint}).success(function(a){c=a.data}).error(function(){c=[]}):c={})):c=this.options.data,a.isArray(c)){for(var d={},e=0;e<c.length;e++){if("string"!=typeof c[e]){b.console.error("Invalid type of data for suggestion."),d={};break}d[c[e]]=c[e]}c=d}for(var f in c)c.hasOwnProperty(f)&&c[f].indexOf(this.options.addedPrefix)>=0&&(c[f]=c[f].replace(this.options.addedPrefix,""));this.autocompleteValues=c,Object.keys(this.autocompleteValues).length<1&&this.setInputDisabled()},parseSelectOptions:function(){var b={};return this.element.find("option").each(function(){var c=a(this);""!==c.attr("value")?b[c.attr("value")]=c.text():b[c.text()]=c.text()}),b},setInputDisabled:function(){this.input.attr("disabled","disabled")},buildContainer:function(){this.element.wrap('<div class="autocomplete-choice-input">'),this.element.parent().css("position","relative")},createInput:function(){this.input=a('<input type="text">'),this.input.attr("class",this.element.attr("class")),this.input.attr("placeholder",this.element.attr("placeholder")),this.element.parent().append(this.input),this.element.hide(),this.options.singleText||(this.elementName=this.element.attr("name"),this.element.attr("name",""))},createSelectedItemsCounter:function(){this.selectedItemsCounter=a('<div class="autocomplete-choice-input-items-counter"></div>'),this.selectedItemsCounter.text(Object.keys(this.selectedData).length),this.element.parent().append(this.selectedItemsCounter),this.selectedItemsCounter.on("click",a.proxy(function(a){this.selectedItemsList.toggle(),a.stopPropagation(a)},this))},createSelectedItemsList:function(){this.selectedData={},this.selectedItemsList=a('<ul class="autocomplete-choice-input-selected-list">'),this.selectedItemsList.hide(),this.element.parent().append(this.selectedItemsList),this.selectedItemsList.css("min-width",this.element.parent().width()),a("html").on("click",a.proxy(function(){this.selectedItemsList.hide()},this))},createAutocompleteList:function(){this.autocompleteList=a('<ul class="autocomplete-choice-input-autocomplete">'),this.updateAutocompleteItemsList({}),this.element.parent().append(this.autocompleteList),this.autocompleteList.css("min-width",this.element.parent().width())},addInputListener:function(){this.options.keyboardSupport===!0?this.addKeyboardSupport():this.input.on("keyup",a.proxy(this.suggestItems,this))},updateSelected:function(){this.updateSelectedItemsList(),this.updateItemsCounter(),this.updateSelectedInput()},updateItemsCounter:function(){this.selectedItemsCounter.text(Object.keys(this.selectedData).length)},updateSelectedItemsList:function(){this.selectedItemsList.find("li").remove(),Object.keys(this.selectedData).length<1&&this.selectedItemsList.hide();var b=this;for(var c in this.selectedData)if(this.selectedData.hasOwnProperty(c)){var d=a("<li>");if(d.attr("id",c),d.text(this.selectedData[c]),this.options.allowEdit&&this.options.allowAdd){var e=a('<span class="edit-button">');e.on("click",b.editSelectedItemButtonCallback(e)),d.prepend(e)}var f=a('<span class="remove-button">');f.on("click",b.removeSelectedItemButtonCallback(f)),d.prepend(f),this.selectedItemsList.append(d)}},removeSelectedItemButtonCallback:function(a){var c=this;return function(){c.removeSelectedItem(a.closest("li")),b.event.stopPropagation()}},editSelectedItemButtonCallback:function(a){var c=this;return function(){b.event.stopPropagation();var d=a.closest("li");c.input.val(d.text()),c.removeSelectedItem(d),c.input.keyup(),c.setFocus()}},updateSelectedInput:function(){if(this.options.singleText)this.element.val(this.getSelectedAsString());else{this.element.parent().find('input[type="hidden"][name="'+this.elementName+'[]"]').remove();for(var b in this.selectedData)if(this.selectedData.hasOwnProperty(b)){var c=a('<input type="hidden">');c.attr("name",this.elementName+"[]"),c.val(b),this.element.parent().append(c)}}},updateAutocompleteItemsList:function(b){if(this.autocompleteList.find("li").remove(),Object.keys(b).length>0||this.options.allowAdd&&this.input.val()?this.autocompleteList.show():this.autocompleteList.hide(),this.options.allowAdd&&"undefined"==typeof b[this.input.val()]){var c=a("<li>");c.attr("id",this.input.val()),c.text(this.options.addText.replace("%item%",this.input.val())),c.on("click",this.createNewItem(c)),this.autocompleteList.append(c)}for(var d in b)if(b.hasOwnProperty(d)){var e=a("<li>");e.attr("id",d),e.text(b[d]),e.on("click",this.suggestedItemClickCallback(e)),this.autocompleteList.append(e)}},suggestedItemClickCallback:function(a){var b=this;return function(){b.addSuggestedItem(a),b.input.val(""),b.updateAutocompleteItemsList({}),b.setFocus()}},createNewItem:function(a){var b=this;return function(){a.text(a.attr("id")),a.attr("id",b.options.addedPrefix+a.attr("id")),b.addSuggestedItem(a),b.input.val(""),b.updateAutocompleteItemsList({}),b.setFocus()}},suggestItems:function(){var a=this.input.val();if(a.length<this.options.minLength)return void this.updateAutocompleteItemsList({});if(!(a in this.cache)){var b={},c=0;for(var d in this.autocompleteValues)if(this.autocompleteValues.hasOwnProperty(d)&&this.autocompleteValues[d].toLowerCase().indexOf(a.toLowerCase())>=0&&(b[d]=this.autocompleteValues[d],++c>=this.options.maxItems))break;this.cache[a]=b}this.updateAutocompleteItemsList(this.cache[a])},addSuggestedItem:function(a){this.selectedData[a.attr("id")]=a.text(),this.updateSelected()},removeSelectedItem:function(a){delete this.selectedData[a.attr("id")],this.updateSelected()},getSelectedAsString:function(){var a="",b="";for(var c in this.selectedData)this.selectedData.hasOwnProperty(c)&&(a+=b+c,b=this.options.singleTextDelimiter);return a},setDefaultSelectedItems:function(){if(this.element.is("select")){var b=this;this.element.find("option").each(function(){var c=a(this);if("selected"===c.attr("selected")){var d=c.attr("value"),e=c.text();"undefined"!=typeof d&&"undefined"!=typeof b.autocompleteValues[d]?b.selectedData[d]=e:"undefined"!=typeof b.autocompleteValues[e]&&(b.selectedData[e]=e)}})}else if(""!==this.element.val()){var c=this.element.val();c=c.split(this.options.singleTextDelimiter);for(var d=0;d<c.length;d++)"undefined"!=typeof this.autocompleteValues[c[d]]&&(this.selectedData[c[d]]=this.autocompleteValues[c[d]])}this.updateSelected(),this.selectedItemsList.hide()},addKeyboardSupport:function(){var b=this;this.element.parent().off("keyup.autocompletechoiceinput").on("keyup.autocompletechoiceinput",a.proxy(function(a){38===a.which?(b.onPressKeyUp(),a.stopPropagation()):40===a.which?(b.onPressKeyDown(),a.stopPropagation()):13===a.which?(b.onPressKeyEnter(),a.stopPropagation()):b.suggestItems()})),this.element.parent().off("keydown.autocompletechoiceinput").on("keydown.autocompletechoiceinput",a.proxy(function(a){if(b.autocompleteList.is(":visible")){if(38===a.which||40===a.which)return!1;13===a.which&&a.preventDefault(a)}}))},onPressKeyUp:function(){if(this.autocompleteList.is(":visible")){var a=this.autocompleteList.find(".active");if(0===a.length)this.autocompleteList.find("li:last-child").addClass("active");else{var b=this.autocompleteList.find("li.active").index();b>0&&(this.autocompleteList.find("li.active").removeClass("active"),this.autocompleteList.find("li:eq("+(b-1)+")").addClass("active"))}}},onPressKeyDown:function(){if(this.autocompleteList.is(":visible")){var a=this.autocompleteList.find(".active");if(0===a.length)this.autocompleteList.find("li:first-child").addClass("active");else{var b=this.autocompleteList.find("li.active").index();b<this.autocompleteList.find("li").length-1&&(this.autocompleteList.find("li.active").removeClass("active"),this.autocompleteList.find("li:eq("+(b+1)+")").addClass("active"))}}},onPressKeyEnter:function(){this.autocompleteList.is(":visible")&&(0!==this.autocompleteList.find("li.active").length?this.autocompleteList.find("li.active").click():this.options.allowAdd&&this.autocompleteList.find("li").first().click())},setFocus:function(){this.input.focus()}}),jQuery.fn[d]=function(b){return this.each(function(){a.data(this,"plugin_"+d)||a.data(this,"plugin_"+d,new c(this,b))})}}(jQuery,window,document);